#ifndef FAST3D_H
#define FAST3D_H

// GeometryMode flags
#define FAST3D_GEOMETYRMODE_CLIPPING			0x00000000
#define FAST3D_GEOMETRYMODE_ZBUFFER				0x00000001
#define FAST3D_GEOMETRYMODE_TEXTURE_ENABLE		0x00000002	// Microcode use only 
#define FAST3D_GEOMETRYMODE_SHADE				0x00000004	// enable Gouraud interp 

#define FAST3D_GEOMETRYMODE_SHADING_SMOOTH		0x00000200	// flat or smooth shaded 
#define FAST3D_GEOMETRYMODE_CULL_FRONT			0x00001000
#define FAST3D_GEOMETRYMODE_CULL_BACK			0x00002000
#define FAST3D_GEOMETRYMODE_CULL_BOTH			0x00003000
#define FAST3D_GEOMETRYMODE_FOG					0x00010000
#define FAST3D_GEOMETRYMODE_LIGHTING			0x00020000
#define FAST3D_GEOMETRYMODE_TEXTURE_GEN			0x00040000
#define FAST3D_GEOMETRYMODE_TEXTURE_GEN_LINEAR	0x00080000
#define FAST3D_GEOMETRYMODE_LOD					0x00100000	// NOT IMPLEMENTED 

// Matrix Flags
#define	FAST3D_MTX_MODELVIEW		0x00
#define	FAST3D_MTX_PROJECTION		0x01

#define	FAST3D_MTX_MUL				0x00
#define	FAST3D_MTX_LOAD				0x02

#define FAST3D_MTX_NOPUSH			0x00
#define FAST3D_MTX_PUSH				0x04

// DisplayList Flags
#define FAST3D_DL_PUSH				0x00
#define FAST3D_DL_NOPUSH			0x01

// MoveWord Types
#define FAST3D_MOVEWORD_MATRIX		0x00
#define FAST3D_MOVEWORD_NUMLIGHT 	0x02
#define FAST3D_MOVEWORD_CLIP		0x04
#define FAST3D_MOVEWORD_SEGMENT		0x06
#define FAST3D_MOVEWORD_FOG			0x08
#define FAST3D_MOVEWORD_LIGHTCOL	0x0a
#define	FAST3D_MOVEWORD_POINTS		0x0c
#define	FAST3D_MOVEWORD_PERSPNORM	0x0e

// MoveMem Types
#define FAST3D_MOVEMEM_VIEWPORT		0x80
#define FAST3D_MOVEMEM_LOOKATY		0x82
#define FAST3D_MOVEMEM_LOOKATX		0x84
#define FAST3D_MOVEMEM_LIGHT0		0x86
#define FAST3D_MOVEMEM_L1GHT1		0x88
#define FAST3D_MOVEMEM_LIGHT2		0x8a
#define FAST3D_MOVEMEM_LIGHT3		0x8c
#define FAST3D_MOVEMEM_LIGHT4		0x8e
#define FAST3D_MOVEMEM_LIGHT5		0x90
#define FAST3D_MOVEMEM_LIGHT6		0x92
#define FAST3D_MOVEMEM_LIGHT7		0x94
#define FAST3D_MOVEMEM_TXTATT		0x96
#define FAST3D_MOVEMEM_MATRIX_1		0x9e
#define FAST3D_MOVEMEM_MATRIX_2		0x98
#define FAST3D_MOVEMEM_MATRIX_3		0x9a
#define FAST3D_MOVEMEM_MATRIX_4		0x9c

void Fast3D_Init();
#endif